///////////////////////////////////////////////////////////////////////////////
// 
//  		:	Handbook
//  		:	FindDialog.cpp
//  		:	23/04/2007
// 
//  	:	      
// 
///////////////////////////////////////////////////////////////////////////////
//
//    COPYRIGHT (c)  2007  Ը 
//
///////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "FindDialog.h"

wxString CFindDialog::m_wxstrFindText;
enum 
{
	wxwidFindInName,
	wxwidFindInDescription,
	wxwidFind,
	wxwidCancel,
};

//  
BEGIN_EVENT_TABLE(CFindDialog,wxDialog)	
	EVT_BUTTON(wxwidFind,CFindDialog::OnFind)
	EVT_BUTTON(wxwidCancel,CFindDialog::OnCancel)
END_EVENT_TABLE()

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    p_pwxwParent -    
//                               -  			                               
//                                                                       
//                :       FindDialog
//                                                                       
//                   :     
//                                                                       
///////////////////////////////////////////////////////////////////////////////
CFindDialog::CFindDialog(wxWindow * parent,
						const wxFont& p_rwxfFont,
						const wxColour& p_rwxcColour,
						const wxColour& p_rwxcBackColour,
						const wxColour& p_rwxcWindowColour)
	:wxDialog(parent,wxID_ANY,_("Find"),wxDefaultPosition,wxSize(320,240))

{
	wxConfigBase * pConfig=wxConfigBase::Get();
	pConfig->SetPath(_T("/FindOptions/"));
	m_bFindInName=pConfig->Read(_T("FindInName"),TRUE);
	m_bFindInDescription=pConfig->Read(_T("FindInDescription"),TRUE);

	this->SetFont(p_rwxfFont);
	this->SetBackgroundColour(p_rwxcWindowColour);
	this->SetForegroundColour(p_rwxcColour);


	m_pwxbtnFind=new wxButton(this,wxwidFind,_("Find"),wxPoint(230,10),wxSize(70,20));
	m_pwxbtnFind->SetFont(p_rwxfFont);
	m_pwxbtnFind->SetBackgroundColour(p_rwxcWindowColour);
	m_pwxbtnFind->SetForegroundColour(p_rwxcColour);

	m_pwxbtnCancel=new wxButton(this,wxwidCancel,_("Cancel"),wxPoint(230,40),wxSize(70,20));
	m_pwxbtnCancel->SetFont(p_rwxfFont);
	m_pwxbtnCancel->SetBackgroundColour(p_rwxcWindowColour);
	m_pwxbtnCancel->SetForegroundColour(p_rwxcColour);

	m_pwxtctrlFindText=new wxTextCtrl(this,wxID_ANY,m_wxstrFindText,wxPoint(10,10),wxSize(200,30));
	m_pwxtctrlFindText->SetBackgroundColour(p_rwxcBackColour);
	m_pwxtctrlFindText->SetFont(p_rwxfFont);
	m_pwxtctrlFindText->SetForegroundColour(p_rwxcColour);

	m_pwxcbFindInName=new wxCheckBox(this,wxwidFindInName,_("Find in name"),wxPoint(10,50));
	m_pwxcbFindInDescription=new wxCheckBox(this,wxwidFindInDescription,_("Find in description"),wxPoint(10,70));

	m_pwxcbFindInName->SetValue(m_bFindInName);
	m_pwxcbFindInDescription->SetValue(m_bFindInDescription);
	m_pwxtctrlFindText->SetFocus();

}
///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    
//                   :     Ը                                          
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    		                               
//                                                                       
//                :      
//                                                                       
//                   :     
//                                                                       
///////////////////////////////////////////////////////////////////////////////
CFindDialog::~CFindDialog()
{
	m_wxstrFindText=m_pwxtctrlFindText->GetValue();
	m_bFindInName=(BOOL)m_pwxcbFindInName->GetValue();
	m_bFindInDescription=(BOOL)m_pwxcbFindInDescription->GetValue();
	wxConfigBase * pConfig=wxConfigBase::Get();
	pConfig->SetPath(_T("/FindOptions/"));
	pConfig->Write(_T("FindInName"),m_bFindInName);
	pConfig->Write(_T("FindInDescription"),m_bFindInDescription);
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    OnFind
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    p_rwxcmdev -  
//                                                                       
//                :     wxID_FIND,  ,  
//                                .
//                               
//                                                                       
//                   :     
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CFindDialog::OnFind(wxCommandEvent & WXUNUSED(p_rwxcmdev))
{
	m_bFindInName=(BOOL)m_pwxcbFindInName->GetValue();
	m_bFindInDescription=(BOOL)m_pwxcbFindInDescription->GetValue();
	m_wxstrFindText=m_pwxtctrlFindText->GetValue();
	this->EndModal(wxID_FIND);
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    OnCancel
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    p_rwxcmdev -  
//                                                                       
//                :        
//                              wxID_CANCEL,  ,  
//                               
//                                                                       
//                   :     
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CFindDialog::OnCancel(wxCommandEvent & WXUNUSED(p_rwxcmdev))
{
	this->EndModal(wxID_CANCEL);
}



