///////////////////////////////////////////////////////////////////////////////
// 
//  		:	Handbook
//  		:	ImageFrame.cpp
//  		:	11/05/2007
// 
//  	:	    
// 
///////////////////////////////////////////////////////////////////////////////
//
//    COPYRIGHT (c)  2007  Ը 
//
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ImageFrame.h"


BEGIN_EVENT_TABLE(CImageFrame,wxPanel)
	EVT_ERASE_BACKGROUND(CImageFrame::OnEraseBackground)
    EVT_PAINT(CImageFrame::OnPaint)
	EVT_SIZE(CImageFrame::OnSize)
END_EVENT_TABLE()
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
wxBitmap g_wxbmp;



///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    		                               
//                                                                       
//                :      
//                                                                       
//                   :     
//                                                                       
///////////////////////////////////////////////////////////////////////////////
CImageFrame::CImageFrame(wxWindow * p_wxwParent)
	:wxPanel(p_wxwParent,wxID_ANY,wxDefaultPosition,wxDefaultSize,wxNO_BORDER )//,wxID_ANY,g_wxbmp)
{
	m_pwximg=NULL;
	m_pwxbmp=NULL;
	m_nxPos=0;
	m_nyPos=0;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    		                               
//                                                                       
//                :     
//                                                                       
//                   :     
//                                                                       
///////////////////////////////////////////////////////////////////////////////
CImageFrame::~CImageFrame()
{
	if (m_pwxbmp) delete m_pwxbmp;
	if (m_pwximg) delete m_pwximg;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    OnPaint
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    wxPaintEvent m_rwxpev	                               
//                                                                       
//                :       
//                             
//                                                                       
//                   :     
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CImageFrame::OnPaint(wxPaintEvent & WXUNUSED(m_rwxpev))
{
	
	wxPaintDC dc(this);
	PrepareDC(dc );
	if (m_pwxbmp)
	{
		
		dc.DrawBitmap(*m_pwxbmp,m_nxPos,m_nyPos,false);
	}
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    SetImage
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    const wxString & p_rwxstrPath -    
//                             ,   	                               
//                                                                       
//                :        
//                                                                       
//                   :     
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CImageFrame::SetImage(const wxString & p_rwxstrPath)
{
	if (p_rwxstrPath=="")
	{
		m_wxstrImageFileName=p_rwxstrPath;
		if (m_pwximg) {delete m_pwximg; m_pwximg=NULL;}
	}
	else
	{
		wxImage wximg;
		if (!wximg.LoadFile(p_rwxstrPath,wxBITMAP_TYPE_ANY ))
			wxMessageBox(wxString(_("Cannot load this image"))+_T("\"") +p_rwxstrPath+_T("\""),_(""));

		else
		{
			m_wxstrImageFileName=p_rwxstrPath;
			if (m_pwximg) {delete m_pwximg; m_pwximg=NULL;}
			m_pwximg=new wxImage(wximg);
		}
	}
	wxSizeEvent wxszev;
	OnSize(wxszev);
	Refresh();
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    OnSize
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    wxSizeEvent & m_rwxpev	                               
//                                                                       
//                :          
//                             .   
//                             .
//                                                                       
//                   :     
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CImageFrame::OnSize(wxSizeEvent & WXUNUSED(m_rwxpev))
{
	wxImage wximgres;
	if (m_pwximg)
	{
		int nWidth,nHeight,nNewWidth,nNewHeight;
		float p,p2;
	
		this->GetSize(&nWidth,&nHeight);
		nNewWidth=nWidth;
		nNewHeight=nHeight;
		if ((nWidth<m_pwximg->GetWidth())||(nHeight<m_pwximg->GetHeight()))
		{
			p=float(m_pwximg->GetWidth())/float(m_pwximg->GetHeight());
			p2=float(nWidth)/float(nHeight);
			if (p>p2)
			{
				nNewHeight=int(float(nWidth)/p);
			}
			else
			{
				nNewWidth=int(float(nHeight)*p);
			}
			if (m_pwxbmp) {delete m_pwxbmp;m_pwxbmp=NULL;}
			wximgres=(m_pwximg->Scale(nNewWidth,nNewHeight) );
		}
		else
		{
			wximgres=(m_pwximg);
		}
		m_pwxbmp=new wxBitmap(wximgres);
		m_nxPos=nWidth/2-(m_pwxbmp->GetWidth()-1)/2;
		m_nyPos=nHeight/2-(m_pwxbmp->GetHeight()-1)/2;
	}
	else
	{
		delete m_pwxbmp; m_pwxbmp=NULL;
	}
	Refresh();
}