///////////////////////////////////////////////////////////////////////////////
// 
//      	:  <Handbook>
//  		:  <mainframe.cpp>
//  		:  7/03/07
// 
//  	:  <    >
// 
///////////////////////////////////////////////////////////////////////////////
//
//    COPYRIGHT (c)  2007.  Ը 
//
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "mainframe.h"


#include "AboutFrame.h"
#include "FindDialog.h"
#include "ImageFrame.h"
#include "data.h"
#include "myapp.h"

wxString g_wxstrWildcard=_("Handbook files")+wxString(" (*.hbk)|*.hbk");
// 
enum 
{
	wxwidBitmap,
	wxwidName,
	wxwidDescription,
	wxwidObjectList,

	// 
	wxwidNew,
	wxwidOpen,
	wxwidSave,
	wxwidExit,

	wxwidPrevious,
	wxwidNext,
	wxwidAdd,
	wxwidRemove,
	wxwidFindFirst,
	wxwidFindNext,

	wxwidChangePicture,
	wxwidNoPicture,

	wxwidSelectFont,
	wxwidSelectBackColour,
	wxwidSelectWindowColour,
	wxwidRestoreDefaultSettings,

	wxwidHelp,
	wxwidAbout,

	
	// ToolBar
	wxwidTool,
	wxwidtlbarNew,
	wxwidtlbarOpen,
	wxwidtlbarSave,
	wxwidtlbarPrevious,
	wxwidtlbarNext,
	wxwidtlbarFind,
	wxwidtlbarAdd,
	wxwidttlbarRemove,

	wxwidLanguage,
	wxwidMaxLanguage=wxwidLanguage+wxLANGUAGE_USER_DEFINED,

	wxwidMax,
};



//  
BEGIN_EVENT_TABLE(CMainFrame,wxFrame)
   EVT_MENU(wxwidNew,CMainFrame::OnNew)
   EVT_MENU(wxwidSave,CMainFrame::OnSave)
   EVT_MENU(wxwidOpen,CMainFrame::OnOpen)
   EVT_MENU(wxwidSelectFont,CMainFrame::OnSelectFont)
   EVT_MENU(wxwidSelectBackColour,CMainFrame::OnSelectBackColour)
   EVT_MENU(wxwidSelectWindowColour,CMainFrame::OnSelectWindowColour)
   EVT_MENU(wxwidAbout,CMainFrame::OnAbout)

   EVT_MENU(wxwidPrevious,CMainFrame::OnPrevious)
   EVT_MENU(wxwidNext,CMainFrame::OnNext)
   EVT_MENU(wxwidAdd,CMainFrame::OnAdd)
   EVT_MENU(wxwidRemove,CMainFrame::OnRemove)
   EVT_MENU(wxwidFindFirst,CMainFrame::OnFindFirst)
   EVT_MENU(wxwidFindNext,CMainFrame::OnFindNext)
   EVT_LISTBOX(wxwidObjectList,CMainFrame::OnListBox)
   EVT_MENU(wxwidExit,CMainFrame::OnExit)
   EVT_MENU(wxwidChangePicture,CMainFrame::OnChangePicture)
   EVT_MENU(wxwidNoPicture,CMainFrame::OnNoPicture)
   EVT_MENU(wxwidRestoreDefaultSettings,CMainFrame::OnRestoreDefaultSettings)
   EVT_MENU_RANGE(wxwidLanguage,wxwidLanguage+wxLANGUAGE_USER_DEFINED,CMainFrame::OnLanguage)
   //EVT_HELP_RANGE(0,wxwidMax,CMainFrame::OnHelp)
   EVT_MENU(wxwidHelp,CMainFrame::OnHelp)
   EVT_CLOSE(CMainFrame::OnClose)
END_EVENT_TABLE()


///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    CMainFrame
//                   :   Ը 
//                    :  7/03/07                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                    
//                                                                       
//                :    CMainFrame.  
//                            
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
CMainFrame::CMainFrame(const wxString & p_wxstrTitle)
	:wxFrame(NULL,wxID_ANY,p_wxstrTitle)

{

	bNew=TRUE;
	m_bChanged=FALSE;
	

	//////////////////////////////////////////////////////////////////////////
	// 
	this->CreateMainMenuBar();
	if (m_pwxmnubar) this->SetMenuBar(m_pwxmnubar);

	//////////////////////////////////////////////////////////////////////////
	// Toolbar
	CreateMainToolBar();


	/////////////////////////////////////////////////////////////////////////
	//  Info Tool
	CreateMainStatusBar();

	/////////////////////////////////////////////////////////////////////////
	// Accelerator-
	CreateMainAcceleratorTable();

	////////////////////////////////////////////////////////////////////////
	// .
	CreateMainInterface();

	///////////////////////////////////////////////////////////////////////
	//  .     
	SetSomeControlsEnable(FALSE);

	//    
	SaveDefaultSettings();



	RestorePositionAndSize();
	LoadSettings();

}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                   
//                                                                       
//                :   .                        
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
CMainFrame::~CMainFrame()
{
  wxConfigBase *pConfig = wxConfigBase::Get();
  if ( pConfig == NULL )
    return;

 
  
  if (this->IsIconized()) this->Iconize(FALSE);
  pConfig->SetPath(_T("/MainFrame/"));
  pConfig->Write(_T("Maximized"),(long) this->IsMaximized());
  if (this->IsMaximized()) this->Maximize(FALSE);
  wxRect wxr=GetRect();
  pConfig->Write(_T("x"), (long) wxr.x);
  pConfig->Write(_T("y"), (long) wxr.y);
  pConfig->Write(_T("w"), (long) wxr.width);
  pConfig->Write(_T("h"), (long) wxr.height);
  pConfig->SetPath(_T("/Controls/"));
  pConfig->Write(_T("swImage"),(long)m_pwxswImage->GetSashPosition());
  pConfig->Write(_T("swObjectList"),(long)m_pwxswObjectList->GetSashPosition());
  pConfig->Write(_T("swName"),(long)m_pwxswName->GetSashPosition());
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  CreateMainMenuBar
//                   :   Ը 
//                    :  6/04/07                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  ytn                                 
//                                                                       
//                :      
//                           
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::CreateMainMenuBar(void)
{
	m_pwxmnubar=new wxMenuBar();

	wxMenu * wxmnu =new wxMenu;
	wxMenuItem * wxmnui;
	wxmnui=new wxMenuItem(wxmnu,wxwidNew,_("&New\tCtrl+N"));
	wxmnu->Append(wxmnui);
	wxmnui=new wxMenuItem(wxmnu,wxwidOpen,_("&Open\tCtrl+O"));
	wxmnu->Append(wxmnui);
	wxmnui=new wxMenuItem(wxmnu,wxwidSave,_("Sa&ve\tCtrl+S"));
	wxmnu->Append(wxmnui);
	wxmnui=new wxMenuItem(wxmnu,wxwidExit,_("E&xit\tCtrl+X"));
	wxmnu->Append(wxmnui);
	m_pwxmnubar->Append(wxmnu,_("&File"));
	
	wxmnu=new wxMenu;
	wxmnui=new wxMenuItem(wxmnu,wxwidPrevious,_("&Previous\tF9"));
	wxmnu->Append(wxmnui);
	wxmnui=new wxMenuItem(wxmnu,wxwidNext,_("&Next\tF10"));
	wxmnu->Append(wxmnui);
	wxmnui=new wxMenuItem(wxmnu,wxwidAdd,_("&Add\tF11"));
	wxmnu->Append(wxmnui);
	wxmnui=new wxMenuItem(wxmnu,wxwidRemove,_("&Remove\tF12"));
	wxmnu->Append(wxmnui);
	wxmnui=new wxMenuItem(wxmnu,wxwidFindFirst,_("&Find\tCtrl+F"));
	wxmnu->Append(wxmnui);
	wxmnui=new wxMenuItem(wxmnu,wxwidFindNext,_("F&ind Next\tCtrl+L"));
	wxmnu->Append(wxmnui);
	m_pwxmnubar->Append(wxmnu,_("&Commands"));


	wxmnu=new wxMenu;
	wxmnui=new wxMenuItem(wxmnu,wxwidChangePicture,_("&Change &picture\tF5"));
	wxmnu->Append(wxmnui);
	wxmnui=new wxMenuItem(wxmnu,wxwidNoPicture,_("&No picture\tF6"));
	wxmnu->Append(wxmnui);
	m_pwxmnubar->Append(wxmnu,_("&Picture"));

	wxmnu=new wxMenu;
	wxmnu->Append(wxwidSelectFont,_("Select &font\tF2"));
	wxmnu->Append(wxwidSelectBackColour,_("Select &back color\tF3"));
	wxmnu->Append(wxwidSelectWindowColour,_("Select &window colour\tF4"));
	wxmnu->Append(wxwidRestoreDefaultSettings,_("Restore default settings"));
	CreateLanguagesMenu();
	wxmnu->Append(wxwidLanguage,_("Language"),m_pwxmnuLanguage);
	m_pwxmnubar->Append(wxmnu,_("&Options"));


	wxmnu=new wxMenu;

	wxmnui=new wxMenuItem(wxmnu,wxwidHelp,_("&Help\tF1"));
	wxmnu->Append(wxmnui);
	wxmnui=new wxMenuItem(wxmnu,wxwidAbout,_("&About"));
	wxmnu->Append(wxmnui);

	m_pwxmnubar->Append(wxmnu,_("&Help"));
}




///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnSelectFont
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent & p_rwxcmdev                                 
//                                                                       
//                :        
//                            
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnSelectFont(wxCommandEvent & WXUNUSED(p_rwxcmdev))
{
	wxFontData data;
    data.SetInitialFont(m_wxfFont);
    data.SetColour(m_wxcColour);

    wxFontDialog wxfdDialog(this, data);
    if ( wxfdDialog.ShowModal() == wxID_OK )
    {
        wxFontData retData = wxfdDialog.GetFontData();
        wxFont font = retData.GetChosenFont();
        wxColour wxcColour = retData.GetColour();

		
        DoChangeFont(font, wxcColour);

       
    }
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnSelectBackColour
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent & p_rwxcmdev                                 
//                                                                       
//                :        
//                                 .
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnSelectBackColour(wxCommandEvent & WXUNUSED(p_rwxcmdev))
{
	wxColourData data;
	data.SetColour(m_wxcBackColour);
	wxColourDialog wxcdDialog(this,&data);
	if (wxcdDialog.ShowModal() == wxID_OK)
	{
		wxColourData retData= wxcdDialog.GetColourData();
		DoChangeBackColour(retData.GetColour());
	}
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  DoChangeFont
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  const wxFont& p_rwxfNewFont -  
//                           const wxColour& p_rwxcNewColour -                                    
//                                                                       
//                :        
//                           .
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::DoChangeFont(const wxFont &p_rwxfNewFont,const wxColour & p_rwxcNewColour)
{
	wxConfigBase * pConfig = wxConfigBase::Get();
	pConfig->SetPath(_T("/Font/"));
	pConfig->Write("Font",p_rwxfNewFont.GetFaceName());
	pConfig->Write("Family",p_rwxfNewFont.GetFamily());
	pConfig->Write("NativeFontInfoDesc",p_rwxfNewFont.GetNativeFontInfoDesc() );
	pConfig->Write("PointSize",p_rwxfNewFont.GetPointSize());
	pConfig->Write("Style",p_rwxfNewFont.GetStyle());
	pConfig->Write("Underlined",p_rwxfNewFont.GetUnderlined());
	pConfig->Write("Weight",p_rwxfNewFont.GetWeight());

	pConfig->SetPath(_T("/Font/Colour/"));
	pConfig->Write("Red",(long)p_rwxcNewColour.Red());
	pConfig->Write("Green",(long)p_rwxcNewColour.Green());
	pConfig->Write("Blue",(long)p_rwxcNewColour.Blue());

	m_wxfFont=p_rwxfNewFont;
	m_wxcColour=p_rwxcNewColour;

	m_pwxtctrlDescription->SetFont(p_rwxfNewFont);
	m_pwxtctrlName->SetFont(p_rwxfNewFont);
	this->SetFont(m_wxfFont);
	m_pwxmnubar->SetFont(m_wxfFont);
	m_pwxstbar->SetFont(m_wxfFont);
	m_pwxtlbar->SetFont(m_wxfFont);
	m_pwxlbObjectList->SetFont(m_wxfFont);
	if (p_rwxcNewColour.Ok())
	{
		m_pwxtctrlDescription->SetForegroundColour(p_rwxcNewColour);
		m_pwxtctrlName->SetForegroundColour(p_rwxcNewColour);
		this->SetForegroundColour(m_wxcColour);
		m_pwxmnubar->SetForegroundColour(m_wxcColour);
		m_pwxstbar->SetForegroundColour(m_wxcColour);
		m_pwxtlbar->SetForegroundColour(m_wxcColour);
		m_pwxlbObjectList->SetForegroundColour(m_wxcColour);
	}
	this->Refresh();
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  DoChangeBackColour
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  const wxColour& p_rwxcNewBackColour
//                                                                       
//                :    ,    
//                              .
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::DoChangeBackColour(const wxColour & p_rwxcNewBackColour)
{
	wxConfigBase * pConfig=wxConfigBase::Get();
	pConfig->SetPath(_T("/Colours/BackColour/"));
	pConfig->Write("Red",(long)p_rwxcNewBackColour.Red());
	pConfig->Write("Green",(long)p_rwxcNewBackColour.Green());
	pConfig->Write("Blue",(long)p_rwxcNewBackColour.Blue());
	m_wxcBackColour=p_rwxcNewBackColour;
	m_pwxtctrlName->SetBackgroundColour(m_wxcBackColour);
	m_pwxtctrlDescription->SetBackgroundColour(m_wxcBackColour);
	m_pwxlbObjectList->SetBackgroundColour(m_wxcBackColour);
	this->Refresh();
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnAbout
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent & p_rwxcmdev                                 
//                                                                       
//                :       
//                               . 
//                               .
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnAbout(wxCommandEvent & WXUNUSED(p_rwxcmdev))
{
	CAboutFrame * cAbout=new  CAboutFrame(this,m_wxfFont,m_wxcColour,m_wxcBackColour,m_wxcWindowColour);
	cAbout->ShowModal();
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  CreateMainAcceleratorTable
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                   
//                                                                       
//                :        
//                            .
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::CreateMainAcceleratorTable(void)
{
	const CountEntries=15;
	wxAcceleratorEntry entries[CountEntries];
	entries[0].Set(wxACCEL_NORMAL,  WXK_F1,    wxwidHelp);
	entries[1].Set(wxACCEL_CTRL,  (int) "N",    wxwidNew);
	entries[2].Set(wxACCEL_CTRL,  (int)"O",    wxwidOpen);
	entries[3].Set(wxACCEL_CTRL,  (int)"S",    wxwidSave);
	entries[4].Set(wxACCEL_CTRL,  (int)"X",    wxwidExit);
	entries[5].Set(wxACCEL_NORMAL,    WXK_F2,    wxwidSelectFont);
	entries[6].Set(wxACCEL_NORMAL,    WXK_F3,    wxwidSelectBackColour);
	entries[7].Set(wxACCEL_NORMAL,    WXK_F9,    wxwidPrevious);
	entries[8].Set(wxACCEL_NORMAL,    WXK_F10,    wxwidNext);
	entries[9].Set(wxACCEL_CTRL,    (int)"F",    wxwidFindFirst);
	entries[10].Set(wxACCEL_CTRL,    WXK_F4,    wxwidSelectWindowColour);
	entries[11].Set(wxACCEL_NORMAL,    WXK_F11,    wxwidAdd);
	entries[12].Set(wxACCEL_NORMAL,     WXK_F12,    wxwidRemove);
	entries[13].Set(wxACCEL_CTRL,     (int)"L",    wxwidRemove);
	entries[12].Set(wxACCEL_NORMAL,     WXK_F5,    wxwidChangePicture);
	entries[13].Set(wxACCEL_NORMAL,     WXK_F6,    wxwidNoPicture);
	wxAcceleratorTable accel(CountEntries, entries);
	this->SetAcceleratorTable(accel);

}


///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnSave
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent & p_rwxcmdev                                 
//                                                                       
//                :        
//                           
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnSave(wxCommandEvent& p_rwxcmdev)
{
	if (!bNew)
		ApplyChanges();
	VerifyNew();
	if (m_wxstrFileName!=_T(""))
	{
		wxString wxstrMessage=_("Cannot save file.");
		ofstream ofsFile;
		ofsFile.open(m_wxstrFileName);
		if (!ofsFile.fail())
		{
			ofsFile<<g_chbHandbook;
			if (!ofsFile.fail())
			{
				ofsFile.close();
				m_bChanged=FALSE;
			}
			else
			{		
				wxMessageBox(wxstrMessage,wxstrMessage,wxOK|wxICON_ERROR);
			}
		}
		else
		{
			wxMessageBox(wxstrMessage,wxstrMessage,wxOK|wxICON_ERROR);
		}
	}
	else
	{
		OnSaveAs(p_rwxcmdev);
	}
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnSave
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent & p_rwxcmdev                                 
//                                                                       
//                :     .  
//                                 
//                             OnSave.
//                           
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnSaveAs(wxCommandEvent& p_rwxcmdev)
{
	wxFileDialog wxfdlg(this);
	wxfdlg.SetWildcard(g_wxstrWildcard);
	wxfdlg.SetStyle(wxSAVE);
	wxString wxstrMessage=_("Cannot save file.");
    if ( wxfdlg.ShowModal() == wxID_OK )
	{
		m_wxstrFileName=wxfdlg.GetPath();
		OnSave(p_rwxcmdev);
	}
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnOpen
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent & p_rwxcmdev                                 
//                                                                       
//                :       -
//                            .
//                           
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnOpen(wxCommandEvent& WXUNUSED(p_rwxcmdev))
{
	if (VerifyChanged()!=wxCANCEL)
	{
		wxFileDialog wxfdlg(this);
		wxString wxstrMessage=_("Cannot open file.");
		wxfdlg.SetWildcard(g_wxstrWildcard);
		if ( wxfdlg.ShowModal() == wxID_OK )
		{
			ifstream ifsFile;
			ifsFile.open(wxfdlg.GetPath(),ios::nocreate);
			if (!ifsFile.fail())
			{
				ifsFile>>g_chbHandbook;
				if (!ifsFile.fail())
				{
					ifsFile.close();
					bNew=FALSE;
					m_wxstrFileName=wxfdlg.GetPath();
					wxString wxstrCurrentDirectory;
					wxFileName::SplitPath(m_wxstrFileName,&wxstrCurrentDirectory,(wxString*)NULL,(wxString*)NULL);
					::wxSetWorkingDirectory(wxstrCurrentDirectory);
					RefreshData();
					RefreshObjectList();
					m_bChanged=FALSE;
					if (g_chbHandbook.GetCurrent()) SetSomeControlsEnable(TRUE);
					else SetSomeControlsEnable(FALSE);
				}
				else
				{		
					wxMessageBox(wxstrMessage,wxstrMessage,wxOK|wxICON_ERROR);
				}
	
			}
			else
			{
			
				wxMessageBox(wxstrMessage,wxstrMessage,wxOK|wxICON_ERROR);
			}
		}
	}//VerifyChanged!=wxCANCEL
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnAdd
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent & p_rwxcmdev                                 
//                                                                       
//                :       
//                               .
//                           
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnAdd(wxCommandEvent& WXUNUSED(p_rwxcmdevEvent))
{
	if (!bNew)
		ApplyChanges();
	VerifyNew();
	m_pwxtctrlName->SetValue(wxString(""));
	m_pwxtctrlDescription->SetValue(wxString(""));
	m_pcimgf->SetImage("");
	bNew=TRUE;
	m_bChanged=TRUE;
	

}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnRemove
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent & p_rwxcmdev                                 
//                                                                       
//                :       
//                              ,   
//                           .
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnRemove(wxCommandEvent& WXUNUSED(p_rwxcmdevEvent))
{
	if (g_chbHandbook.GetCurrent()!=NULL)
	{
		if (wxMessageBox(_("Remove this record?"),_("Remove "),wxYES_NO)==wxYES)
		{
			if (!bNew)
			{
				unsigned unPosition=m_pwxlbObjectList->GetSelection();;
				g_chbHandbook.Remove();
				if ((g_chbHandbook.IsFree())) bNew=TRUE;
				m_pwxlbObjectList->Delete(m_pwxlbObjectList->GetSelection());
				if (m_pwxlbObjectList->GetCount()<=(int)unPosition)  unPosition--;
				m_pwxlbObjectList->SetSelection(unPosition);
				RefreshData();
				if (!g_chbHandbook.GetCurrent()) SetSomeControlsEnable(FALSE);
			}
			else
			{
				g_chbHandbook.SetCurrent(g_chbHandbook.GetFirstObject(),0);
				m_pwxlbObjectList->SetSelection(0);
				RefreshData();
			}
			m_bChanged=TRUE;
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnNext
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent & p_rwxcmdev                                 
//                                                                       
//                :       
//                              .                           
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnNext(wxCommandEvent& WXUNUSED(p_rwxcmdev))
{
	if (!bNew)
		ApplyChanges();
	VerifyNew();
	g_chbHandbook.Next();
	int nSelection=m_pwxlbObjectList->GetSelection();
	if (nSelection<m_pwxlbObjectList->GetCount()-1) m_pwxlbObjectList->SetSelection(nSelection+1);
	RefreshData();
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnPrevious
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent & p_rwxcmdev                                 
//                                                                       
//                :       
//                              .                         
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnPrevious(wxCommandEvent& WXUNUSED(p_rwxcmdev))
{
	if (!bNew)
	ApplyChanges();
	VerifyNew();
	g_chbHandbook.Previous();
	int nSelection=m_pwxlbObjectList->GetSelection();
	if (nSelection>0)m_pwxlbObjectList->SetSelection(nSelection-1);
	RefreshData();
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  VerifyNew
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                   
//                                                                       
//                :     ,  
//                                .   ,
//                           (      )  
//                                 
//                           .                          
//                                                                       
//                   :  TRUE -   , FALSE   .
//                                                                       
///////////////////////////////////////////////////////////////////////////////
BOOL CMainFrame::VerifyNew(void)
{
	if ((g_chbHandbook.IsFree())) bNew=TRUE;
	if (!bNew) return FALSE;
	if ((m_pwxtctrlName->GetValue()==wxString(""))&&
		(m_pwxtctrlDescription->GetValue()==wxString(""))) 
	{
		bNew=FALSE;
		return FALSE;
	}
	CObject co;
	co.SetName(m_pwxtctrlName->GetValue());
	co.SetDescription(m_pwxtctrlDescription->GetValue());
	co.SetImageFileName(m_pcimgf->GetImageFileName());
	g_chbHandbook.Add(co);
	m_pwxlbObjectList->Insert(co.GetName(),g_chbHandbook.GetCurrentPosition(),(void *)g_chbHandbook.GetCurrent());
	m_pwxlbObjectList->SetSelection(g_chbHandbook.GetCurrentPosition());
	bNew=FALSE;
	SetSomeControlsEnable(TRUE);
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  ApplyChanges
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                  
//                                                                       
//                :   .
//                                                                                                
//                   :  TRUE -    , FALSE - 
//                           .
//                                                                       
///////////////////////////////////////////////////////////////////////////////
BOOL CMainFrame::ApplyChanges(void)
{
	CObject co,co2;
	co.SetName(m_pwxtctrlName->GetValue());
	co.SetDescription(m_pwxtctrlDescription->GetValue());
	co.SetImageFileName(m_pcimgf->GetImageFileName());
	co2.SetName(g_chbHandbook.GetName());
	co2.SetDescription(g_chbHandbook.GetDescription());
	co2.SetImageFileName(g_chbHandbook.GetImageFileName());
	if (co!=co2)
	{
		unsigned unPosition=g_chbHandbook.GetCurrentPosition();
		g_chbHandbook.Remove();
		m_pwxlbObjectList->Delete(unPosition);
		g_chbHandbook.Add(co);
		m_pwxlbObjectList->Insert(co.GetName(),(int)g_chbHandbook.GetCurrentPosition(),(void*)g_chbHandbook.GetCurrent());
		m_bChanged=TRUE;
	}
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  RefreshData
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                   
//                                                                       
//                :     .                          
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::RefreshData(void)
{
	m_pwxtctrlName->SetValue(g_chbHandbook.GetName());
	m_pwxtctrlDescription->SetValue(g_chbHandbook.GetDescription());
	if (g_chbHandbook.GetImageFileName()!="") m_pcimgf->SetImage(g_chbHandbook.GetImageFileName());
	else m_pcimgf->SetImage("");
	wxString wxstrMess=_("Count of objects: ");
	m_pwxstbar->SetStatusText(wxString::Format(wxstrMess+"%u",g_chbHandbook.GetCountObjects()));
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnFindFirst
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent & p_rwxcmdev                                 
//                                                                       
//                :       
//                             ,  
//                           .     
//                             .                           
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnFindFirst(wxCommandEvent& WXUNUSED(p_rwxcmdev))
{
	CFindDialog * cfd=new CFindDialog(this,m_wxfFont,m_wxcColour,m_wxcBackColour,m_wxcWindowColour);
	if (cfd->ShowModal()==wxID_FIND)
	{
		g_chbHandbook.FindFirst(cfd->GetFindText(),cfd->GetFindInName(),cfd->GetFindInDescription());
	}
	cfd->Destroy();
	RefreshData();
	m_pwxlbObjectList->SetSelection(g_chbHandbook.GetCurrentPosition());
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnFindNext
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent & p_rwxcmdev                                 
//                                                                       
//                :       
//                             .   
//                            ,  
//                           .                         
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnFindNext(wxCommandEvent& WXUNUSED(p_rwxcmdev))
{
	g_chbHandbook.FindNext();
	m_pwxlbObjectList->SetSelection(g_chbHandbook.GetCurrentPosition());
	RefreshData();
}


///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  CreateMainToolBar
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                   
//                                                                       
//                :     .                          
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::CreateMainToolBar(void)
{
	m_pwxtlbar=this->CreateToolBar();
	if (m_pwxtlbar)
	{
		m_pwxtlbar->AddTool(wxwidNew,wxT(""),wxBitmap(wxString("IDB_NEW")),_("Create new data base"));
		
		m_pwxtlbar->AddTool(wxwidOpen,wxT(""),wxBitmap(wxString("IDB_OPEN")),_("Open existing data base"));
		
		m_pwxtlbar->AddTool(wxwidSave,wxT(""),wxBitmap(wxString("IDB_SAVE")),_("Save this data base"));
		
		m_pwxtlbar->AddSeparator();
		m_pwxtlbar->AddTool(wxwidPrevious,wxT(""),wxBitmap(wxString("IDB_PREVIOUS")),_("Go to previous object"));
		
		m_pwxtlbar->AddTool(wxwidNext,wxT(""),wxBitmap(wxString("IDB_NEXT")),_("Go to next object"));
		m_pwxtlbar->AddTool(wxwidFindFirst,wxT(""),wxBitmap(wxString("IDB_FIND")),_("Find object"));
		m_pwxtlbar->AddTool(wxwidFindNext,wxT(""),wxBitmap(wxString("IDB_FINDNEXT")),_("Find next object"));
		m_pwxtlbar->AddTool(wxwidAdd,wxT(""),wxBitmap(wxString("IDB_ADD")),_("Add new object"));
		m_pwxtlbar->AddTool(wxwidRemove,wxT(""),wxBitmap(wxString("IDB_REMOVE")),_("Remove this object"));
		
		m_pwxtlbar->AddSeparator();
		m_pwxtlbar->AddTool(wxwidChangePicture,wxT(""),wxBitmap(wxString("IDB_CHANGEPICTURE")),_("Change picture"));
		m_pwxtlbar->AddTool(wxwidNoPicture,wxT(""),wxBitmap(wxString("IDB_NOPICTURE")),_("No picture"));
		m_pwxtlbar->AddSeparator();
		m_pwxtlbar->AddTool(wxwidAbout,_("About"),wxBitmap(wxString("IDB_ABOUT")),_("See about box..."));
		m_pwxtlbar->Realize();
	}	
}


///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  CreateMainToolBar
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                   
//                                                                       
//                :     .                          
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::CreateMainStatusBar(void)
{
	m_pwxstbar=this->CreateStatusBar(2,wxST_SIZEGRIP,wxID_ANY,wxT("Status bar"));
	if (m_pwxstbar)
	{
		m_pwxstbar->SetStatusText(wxT("INFO"),1);
	}
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  CreateMainInterface
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                   
//                                                                       
//                :   .                          
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::CreateMainInterface()
{
	wxConfigBase * pConfig = wxConfigBase::Get();
	wxBitmap bmp;


	pConfig->SetPath(_T("/Controls/"));

	long 
		nswImage =      pConfig->Read(_T("swImage"),0l),
		nswObjectList = pConfig->Read(_T("swObjectList"),0l),
		nswName =       pConfig->Read(_T("swName"),0l);


	// ,        
	m_pwxswObjectList= new wxSplitterWindow(this,
									wxID_ANY,
									wxDefaultPosition,
									wxDefaultSize,
									wxSP_3DSASH );
	
	m_pwxswName=new wxSplitterWindow(m_pwxswObjectList,
									wxID_ANY,
									wxDefaultPosition,
									wxDefaultSize,
									wxSP_3DSASH );

	//  Splitter,      
	//   
	m_pwxswImage=new wxSplitterWindow(m_pwxswName,
									wxID_ANY,
									wxDefaultPosition,
									wxDefaultSize,
									wxSP_3DSASH );


	//   ,      -
	//  
	m_pcimgf=new CImageFrame(m_pwxswImage);

	m_pwxlbObjectList = new wxListBox(m_pwxswObjectList,
										wxwidObjectList);

	//  ,        
	//
	m_pwxtctrlName= new wxTextCtrl(m_pwxswName,
		                       wxwidName);


	//  ,      
	m_pwxtctrlDescription = new wxTextCtrl(m_pwxswImage,
		                                    wxwidDescription,
											_T(""),
											wxDefaultPosition,
											wxDefaultSize,
							   wxTE_WORDWRAP|wxTE_MULTILINE );

	m_pwxswObjectList->SplitVertically(m_pwxlbObjectList,m_pwxswName,nswObjectList);
	m_pwxswName->SplitHorizontally(m_pwxtctrlName,m_pwxswImage,nswName);
	m_pwxswImage->SplitVertically(m_pwxtctrlDescription,m_pcimgf,nswImage);
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  RestorePositionAndAxis
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                   
//                                                                       
//                :     , 
//                             .                          
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::RestorePositionAndSize()
{
   wxConfigBase *pConfig = wxConfigBase::Get();
   pConfig->SetPath(_T("/MainFrame/"));
   // restore frame position and size
   wxRect wxr;
      wxr.SetX ( pConfig->Read(_T("x"), 50)),
      wxr.SetY ( pConfig->Read(_T("y"), 50)),
      wxr.SetWidth ( pConfig->Read(_T("w"), 350)),
      wxr.SetHeight ( pConfig->Read(_T("h"), 200));
	
	BOOL bMaximized=pConfig->Read(_T("Maximized"),(long)FALSE);
	if (bMaximized) this->Maximize(TRUE);
	SetSize(wxr);
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  RefreshObjectList
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                   
//                                                                       
//                :    .                         
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::RefreshObjectList(void)
{
	CObjectListItem * coli=g_chbHandbook.GetFirstObject();
	m_pwxlbObjectList->Clear();
	int n=0;
	while (coli)
	{
		m_pwxlbObjectList->Insert(coli->GetName(),n,(void *)coli);
		n++;
		coli=coli->GetNext();
	}
	if (n>0)
	{
		m_pwxlbObjectList->SetSelection(0);
	}
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnSelectWindowColour
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                   
//                                                                       
//                :       
//                             .                          
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnSelectWindowColour(wxCommandEvent & WXUNUSED(p_rwxcmdev))
{
	wxColourData data;
	data.SetColour(m_wxcWindowColour);
	wxColourDialog wxcdDialog(this,&data);
	if (wxcdDialog.ShowModal() == wxID_OK)
	{
		wxColourData retData= wxcdDialog.GetColourData();
		DoChangeWindowColour(retData.GetColour());
	}
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  DoChangeWindowColour
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  const wxColour& p_rwxcNewWindowColour -  
//                            .
//                                                                       
//                :     , 
//                             .                          
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::DoChangeWindowColour(const wxColour & p_rwxcNewWindowColour)
{
	wxConfigBase * pConfig=wxConfigBase::Get();
	pConfig->SetPath(_T("/Colours/WindowColour/"));
	pConfig->Write("Red",(long)p_rwxcNewWindowColour.Red());
	pConfig->Write("Green",(long)p_rwxcNewWindowColour.Green());
	pConfig->Write("Blue",(long)p_rwxcNewWindowColour.Blue());
	m_wxcWindowColour=p_rwxcNewWindowColour;
	m_pwxtlbar->SetBackgroundColour(p_rwxcNewWindowColour);
	m_pwxtlbar->SetBackgroundColour(m_wxcWindowColour);
	m_pwxstbar->SetBackgroundColour(m_wxcWindowColour);
	m_pwxmnubar->SetBackgroundColour(m_wxcWindowColour);
	m_pcimgf->SetBackgroundColour(m_wxcWindowColour);
	this->SetBackgroundColour(m_wxcBackColour);
	Refresh();
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnListBox
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent& p_rwxcmdev                                 
//                                                                       
//                :                              
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnListBox(wxCommandEvent& WXUNUSED(p_rwxcmdev))
{
	if (!bNew)
		ApplyChanges();
	VerifyNew();
	unsigned n=m_pwxlbObjectList->GetSelection();
	if (n==wxNOT_FOUND) 
		m_pwxlbObjectList->SetSelection(g_chbHandbook.GetCurrentPosition());
	else
		g_chbHandbook.SetCurrent((CObjectListItem *) m_pwxlbObjectList->GetClientData(n),n );
	RefreshData();
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnNew
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent& p_rwxcmdev                                 
//                                                                       
//                :       
//                            .
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnNew(wxCommandEvent& WXUNUSED(p_rwxcmdev))
{
	if (wxMessageBox(_("Are you really want to create new database?"),g_wxstrHandbook,wxYES_NO)==wxYES)
	{
		if (VerifyChanged()!=wxCANCEL)
		{
			g_chbHandbook.RemoveAll();
			RefreshData();
			RefreshObjectList();
			SetSomeControlsEnable(FALSE);
			wxCommandEvent wxcmdev;
			OnSaveAs(wxcmdev);
		}
		
	}
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnSomeControlsEnable
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  BOOL p_bEnable -  :
//                                   TRUE - 
//                                   FALSE - 
//                                                                       
//                :        /
//                           .  - ,   
//                           ,       
//                           .    ,  ...                        
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::SetSomeControlsEnable(BOOL p_bEnable)
{
	m_pwxtlbar->EnableTool(wxwidPrevious,p_bEnable);
	m_pwxtlbar->EnableTool(wxwidNext,p_bEnable);
	m_pwxtlbar->EnableTool(wxwidRemove,p_bEnable);
	m_pwxtlbar->EnableTool(wxwidFindFirst,p_bEnable);
	m_pwxtlbar->EnableTool(wxwidFindNext,p_bEnable);
	m_pwxmnubar->Enable(wxwidPrevious,p_bEnable);
	m_pwxmnubar->Enable(wxwidNext,p_bEnable);
	m_pwxmnubar->Enable(wxwidRemove,p_bEnable);
	m_pwxmnubar->Enable(wxwidFindFirst,p_bEnable);
	m_pwxmnubar->Enable(wxwidFindNext,p_bEnable);
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnExit
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent& p_rwxcmdev                                 
//                                                                       
//                :     .                       
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnExit(wxCommandEvent& WXUNUSED(p_rwxcmdev))
{
	wxCloseEvent wxclsev;
	wxclsev.SetCanVeto(TRUE);
	OnClose(wxclsev);

}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  DoChangePicture
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent& p_rwxcmdev                                 
//                                                                       
//                :       
//                           ChangePicture                       
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnChangePicture(wxCommandEvent& WXUNUSED(p_rwxcmdev))
{
	wxFileDialog wxfdlg(this,_("Choose picture"));
	wxfdlg.SetStyle(wxOPEN);
	if (wxfdlg.ShowModal() == wxID_OK)
	{
		wxString wxstrPath=wxfdlg.GetPath();
		wxString wxstrCurrentDirectory=::wxGetCwd();
	
		wxString wxstrTemp=wxstrPath.Left(wxstrCurrentDirectory.Length());

		if ((wxstrTemp==wxstrCurrentDirectory)&&(wxstrCurrentDirectory!=""))
			  wxstrPath=wxstrPath.Right(wxstrPath.Length()-wxstrCurrentDirectory.Length()-1);
		m_pcimgf->SetImage(wxstrPath);
	
	}
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnNoPicture
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent& p_rwxcmdev                                 
//                                                                       
//                :    No picture -  
//                            .    
//                              .
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnNoPicture(wxCommandEvent& WXUNUSED(p_rwxcmdev))
{
	m_pcimgf->SetImage("");
}


///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  LoadOptions
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                   
//                                                                       
//                :                          
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::LoadSettings(void)
{
	wxConfigBase * pConfig=wxConfigBase::Get();
	pConfig->SetPath(_T("/Colours/BackColour/"));
	wxColour wxc;
	wxColour def=m_pwxtctrlName->GetBackgroundColour();

	wxc.Set(
		pConfig->Read(_T("Red"),def.Red()),
		pConfig->Read(_T("Green"),def.Green()),
		pConfig->Read(_T("Blue"),def.Blue()));
	DoChangeBackColour(wxc);

	pConfig->SetPath(_T("/Colours/WindowColour/"));
	def=m_pwxtlbar->GetBackgroundColour();

	wxc.Set(
		pConfig->Read(_T("Red"),def.Red()),
		pConfig->Read(_T("Green"),def.Green()),
		pConfig->Read(_T("Blue"),def.Blue()));
	DoChangeWindowColour(wxc);


	pConfig->SetPath(_T("/Font/Colour/"));
	def=m_pwxtctrlName->GetForegroundColour();

	wxc.Set(
		pConfig->Read(_T("Red"),def.Red()),
		pConfig->Read(_T("Green"),def.Green()),
		pConfig->Read(_T("Blue"),def.Blue()));


	pConfig->SetPath(_T("/Font/"));
	wxFont f=m_pwxtctrlName->GetFont();
	wxFont newf;
	wxString wxstrFaceName=(pConfig->Read(_T("Font"),f.GetFaceName()));
	newf.SetFaceName(wxstrFaceName);
	newf.SetFamily(pConfig->Read("Family",f.GetFamily()));
	newf.SetNativeFontInfo(pConfig->Read("NativeFontInfoDesc",f.GetNativeFontInfoDesc() ));
	newf.SetPointSize(pConfig->Read("PointSize",f.GetPointSize()));
	newf.SetStyle(pConfig->Read("Style",f.GetStyle()));
	newf.SetUnderlined(pConfig->Read("Underlined",f.GetUnderlined()));
	newf.SetWeight(pConfig->Read("Weight",f.GetWeight()));

	DoChangeFont(newf,wxc);
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  SaveDefaultOptions
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                
//                                                                       
//                :                            
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::SaveDefaultSettings(void)
{
	m_wxfFont=this->GetFont();
	m_wxcColour=this->GetForegroundColour();
	m_wxcBackColour=m_pwxtctrlName->GetBackgroundColour();
	m_wxcWindowColour=m_pwxtlbar->GetBackgroundColour();

	m_wxfDefaultFont=m_wxfFont;
	m_wxcDefaultColour=m_wxcColour;
	m_wxcDefaultBackColour=m_wxcBackColour;
	m_wxcDefaultWindowColour=m_wxcWindowColour;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  CreateLanguagesMenu
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                  
//                                                                       
//                :                             
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::CreateLanguagesMenu(void)
{
	m_pwxmnuLanguage=new wxMenu();
	int  n;
	wxString wxstrLanguageName;
	for (n=wxLANGUAGE_DEFAULT; n<wxLANGUAGE_USER_DEFINED; n++)
	{
		switch (n)
		{
		case wxLANGUAGE_DEFAULT:
			{
				m_pwxmnuLanguage->InsertRadioItem(n,wxwidLanguage+n,_("Default"));				
				break;
			}
		case wxLANGUAGE_UNKNOWN:
			{
				m_pwxmnuLanguage->InsertRadioItem(n,wxwidLanguage+n,wxLocale::GetLanguageName(n));
				break;
			}
		default:
			{
				m_pwxmnuLanguage->InsertRadioItem(n,wxwidLanguage+n,wxLocale::GetLanguageName(n));
				break;
			}
		}

	}
	m_pwxmnuLanguage->Check(wxwidLanguage+g_nLocale,TRUE);
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnLanguage
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent& p_rwxcmdev                                 
//                                                                       
//                :                        
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnLanguage(wxCommandEvent& p_rwxcmdev)
{
	g_nLocale=p_rwxcmdev.GetId()-wxwidLanguage;
	wxFileConfig *pConfig = new wxFileConfig("Handbook");
	wxConfigBase::Set(pConfig);

	pConfig->SetPath(_T("/Options/"));
	pConfig->Write(_T("LanguageId"),g_nLocale);
	
	m_pwxmnuLanguage->Check(wxwidLanguage+g_nLocale,TRUE);
	wxMessageBox(_("Restart program to change language."),g_wxstrHandbook);
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  RestoreDefaultOptions
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent& p_rwxcmdev                                 
//                                                                       
//                :                           
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnRestoreDefaultSettings(wxCommandEvent& WXUNUSED(p_rwxcmdev))
{
	DoChangeFont(m_wxfDefaultFont,m_wxcDefaultColour);
	DoChangeBackColour(m_wxcDefaultBackColour);
	DoChangeWindowColour(m_wxcDefaultWindowColour);
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  VerifyChanged
//                   :   Ը 
//                    :  18/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                   
//                                                                       
//                :      
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
int CMainFrame::VerifyChanged(void)
{
	int nret=wxYES;
	if (m_bChanged)
	{
		if ((nret=wxMessageBox(wxString(_("Save changes to "))+_T("\"")+m_wxstrFileName+_T("\".\?"),g_wxstrHandbook,wxYES_NO|wxCANCEL))==wxYES)
		{
			wxCommandEvent cmdev;
			OnSave(cmdev);
		}
	}
	return nret;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnClose
//                   :   Ը 
//                    :  21/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCloseEvent& p_rwxclsev                                 
//                                                                       
//                :    
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnClose(wxCloseEvent& p_rwxclsev)
{
	if (p_rwxclsev.CanVeto())
	{
		if (VerifyChanged()!=wxCANCEL)
		{
			this->Destroy();
		}
		else
		{
			p_rwxclsev.Veto();
		}

	}
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  OnHelp
//                   :   Ը 
//                    :  21/05/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  wxCommandEvent & p_rwxcmdpev                               
//                                                                       
//                :   
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnHelp(wxCommandEvent & p_rwxcmdev)
{
	m_wxhcHelp.DisplayContents();
}


