///////////////////////////////////////////////////////////////////////////////
// 
//      	:  <Handbook>
//  		:  <mainframe.h>
//  		:  7/03/07
// 
//  	:  <    >
// 
///////////////////////////////////////////////////////////////////////////////
//
//    COPYRIGHT (c)  2007.  Ը 
//
///////////////////////////////////////////////////////////////////////////////

#include <wx/wx.h>
#include "ImageFrame.h"
class CMainFrame:public wxFrame
{
private:
	wxHelpController  m_wxhcHelp;
	BOOL bNew;
	wxTextCtrl * m_pwxtctrlName;
	CImageFrame * m_pcimgf;
	wxTextCtrl * m_pwxtctrlDescription;
	wxMenuBar *m_pwxmnubar;
	wxMenu * m_pwxmnuLanguage;
	wxToolBar *m_pwxtlbar;
	wxStatusBar * m_pwxstbar;
	wxListBox * m_pwxlbObjectList;
	
	wxSplitterWindow * m_pwxswImage;//    
	wxSplitterWindow * m_pwxswName;//    
	wxSplitterWindow * m_pwxswObjectList;//    
											//  


	wxFont   m_wxfFont;
	wxColour m_wxcColour;
	wxColour m_wxcBackColour;
	wxColour m_wxcWindowColour;

	wxFont   m_wxfDefaultFont;
	wxColour m_wxcDefaultColour;
	wxColour m_wxcDefaultBackColour;
	wxColour m_wxcDefaultWindowColour;


	BOOL m_bChanged;
	wxString m_wxstrFileName;

	void CreateMainMenuBar(void);
	void CreateMainAcceleratorTable(void);
	void CreateMainToolBar(void);
	void CreateMainStatusBar(void);
	void CreateMainInterface(void);
	void CreateLanguagesMenu(void);
	void RestorePositionAndSize(void);
	void InitializeHelp(void);

	void DoChangeFont(const wxFont &p_rwxfNewFont,const wxColour &p_rwxcNewColour);
	void DoChangeBackColour(const wxColour & p_rwxcNewBackColour);
	void DoChangeWindowColour(const wxColour & p_rwxcNewWindowColour);

public:
	CMainFrame(const wxString& p_wxstrTitle);
	~CMainFrame() ;

	BOOL VerifyNew(void);
	BOOL ApplyChanges(void);
	void RefreshData(void);
	void RefreshObjectList(void);
	void SetSomeControlsEnable(BOOL p_bEnable);

	
	void OnSelectFont(wxCommandEvent & p_rwxcmdev);
	void OnSelectBackColour(wxCommandEvent & WXUNUSED(p_rwxcmdev));
	void OnSelectWindowColour(wxCommandEvent & WXUNUSED(p_rwxcmdev));
	void OnAbout(wxCommandEvent & WXUNUSED(p_rwxcmdev));
	void OnHelp(wxCommandEvent & p_rwxcmdev);
	void OnSave(wxCommandEvent& p_rwxcmdev);
	void OnSaveAs(wxCommandEvent& p_rwxcmdev);
	void OnOpen(wxCommandEvent& WXUNUSED(p_rwxcmdev));
	void OnNew(wxCommandEvent& WXUNUSED(p_rwxcmdev));

	void OnNext(wxCommandEvent& WXUNUSED(p_rwxcmdev));
	void OnPrevious(wxCommandEvent& WXUNUSED(p_rwxcmdev));
	void OnAdd(wxCommandEvent& WXUNUSED(p_rwxcmdev));
	void OnRemove(wxCommandEvent& WXUNUSED(p_rwxcmdev));

	void OnFindFirst(wxCommandEvent& WXUNUSED(p_rwxcmdev));
	void OnFindNext(wxCommandEvent& WXUNUSED(p_rwxcmdev));

	void OnListBox(wxCommandEvent& WXUNUSED(p_rwxcmdev));
	void OnExit(wxCommandEvent& WXUNUSED(p_rwxcmdev));

	void OnPaint(wxPaintEvent& p_rwxpnt);

	void OnChangePicture(wxCommandEvent& WXUNUSED(p_rwxcmdev));
	void OnNoPicture(wxCommandEvent& WXUNUSED(p_rwxcmdev));
	void OnLanguage(wxCommandEvent& p_rwxcmdev);
	void OnRestoreDefaultSettings(wxCommandEvent& WXUNUSED(p_rwxcmdev));
	void OnClose(wxCloseEvent& p_rwxclsev);

	void LoadSettings(void);
	void SaveDefaultSettings(void);

	int VerifyChanged(void);
	wxHelpController& GetHelpController() { return m_wxhcHelp; }
	DECLARE_EVENT_TABLE()
};




