///////////////////////////////////////////////////////////////////////////////
// 
//  Project		:	Handbook
//  Module		:	ObjectList.cpp
//  Date		:	11/05/2007
// 
//  Content		:	  ,     
//                   
// 
///////////////////////////////////////////////////////////////////////////////
//
//    COPYRIGHT (c)  2007  Ը 
//
///////////////////////////////////////////////////////////////////////////////


#include "stdafx.h"
#include "objectlist.h"

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  
//                   :   Ը 
//                    :  6/03/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                
//                                                                       
//                :    .
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
CObjectList::~CObjectList()
{
	RemoveAll();

};

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  Add
//                   :   Ը 
//                    :  6/03/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  CObject& p_rco  .   
//                                      .
//                           unsigned & p_runPosition.   
//                                      .  -  
//                                      .  -   
//                                       
//                           CObjectListItem* & p_pcoliNewObject - 
//                                      .  .
//                                                                      
//                                                                       
//                :                           
//                                                                       
//                   :  TRUE   , FALSE -   .
//                                                                       
///////////////////////////////////////////////////////////////////////////////
BOOL CObjectList::Add(CObject & p_rco,unsigned &p_runPosition,CObjectListItem    * &  p_pcoliNewObject)
{

	unsigned un=0;
	if (!m_pcoliHead)
	{
		m_pcoliTail=new CObjectListItem(p_rco);
		if (!m_pcoliTail) return FALSE;
		m_pcoliHead=m_pcoliTail;
		p_pcoliNewObject=m_pcoliHead;
	}
	else 
	{
		CObjectListItem *coli=m_pcoliHead;
		while (coli)
		{
			if (coli->GetName()>p_rco.GetName()) break;
			coli=coli->GetNext ();
			un++;
		}
		if (coli)
		{
			if (!coli->AddBefore(p_rco)) return FALSE;
			if (coli==m_pcoliHead) 
			{
				m_pcoliHead=coli->GetPrevious();
				
			}
			p_pcoliNewObject=coli->GetPrevious();
		}
		else
		{
			if (!m_pcoliTail->AddAfter(p_rco)) return FALSE;
			m_pcoliTail=m_pcoliTail->GetNext();
			p_pcoliNewObject=m_pcoliTail;
		}
		
	}

	p_runPosition=un;
	m_unCountObjects++;
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  Remove
//                   :   Ը 
//                    :  6/03/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  CObjectListItem& p_rcoli  - ,  
//                           .     !!!
//                                                                       
//                :   .                       
//                                                                       
//                   :  TRUE   , FALSE -   .
//                                                                       
///////////////////////////////////////////////////////////////////////////////
BOOL CObjectList::Remove(CObjectListItem& p_rcoli)
{

	if (m_pcoliHead==&p_rcoli) m_pcoliHead=p_rcoli.GetNext();
	if (m_pcoliTail==&p_rcoli) m_pcoliTail=p_rcoli.GetPrevious();
	p_rcoli.~CObjectListItem();

	m_unCountObjects--;
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  Find
//                   :   Ը 
//                    :  6/03/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  CObjectListItem * p_pcoliFirst - ,  
//                               ().   
//                           CObject & p_rcoFind - ,   
//                             .
//                           unsigned& p_runPosition -  .
//                                , 
//                             p_pcoliFirst.                          
//                                                                       
//                :    ,   .
//                             ,      ,
//                                 p_pcoFind.   
//                              ,    
//                            p_pcoFind.   p_runPosition 
//                                , 
//                             . ,  p_pcoliFirst 
//                             0.
//                                                                       
//                   :  CObjectListItem * -    .
//                                                                       
///////////////////////////////////////////////////////////////////////////////
CObjectListItem * CObjectList::Find(CObjectListItem *p_pcoliFirst,
									CObject& p_rcoFind,
									unsigned& p_runPosition)
{
	CObjectListItem *coli=p_pcoliFirst;
	unsigned unPos=0;
	while (coli)
	{
		if ((coli->GetName()).Find(p_rcoFind.GetName())!=-1) break;
		if ((coli->GetDescription()).Find(p_rcoFind.GetDescription())!=-1) break;
		coli=coli->GetNext();
		unPos++;
	}
	p_runPosition=unPos;
	return coli;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  RemoveAll
//                   :   Ը 
//                    :  6/03/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                               
//                                                                       
//                :    .                      
//                                                                       
//                   :  TRUE -   
//                                                                       
///////////////////////////////////////////////////////////////////////////////
BOOL CObjectList::RemoveAll(void)
{
	CObjectListItem * pcoli=m_pcoliHead;

	if (pcoli)
	{
		while (pcoli->GetNext())
		{
			pcoli=pcoli->GetNext();
			if (!Remove(*pcoli->GetPrevious())) return FALSE;
		}
	}
	m_pcoliHead=NULL;
	m_pcoliTail=NULL;
	m_unCountObjects=0;
	return TRUE;
}