///////////////////////////////////////////////////////////////////////////////
// 
//        :  Handbook
//        :  objectlistitem.h
//          :  7/03/07
// 
//      :       CObjectList,   
//                 ,    
// 
///////////////////////////////////////////////////////////////////////////////
//
//    COPYRIGHT (c)  2007.  Ը 
//
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "objectlistitem.h"

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  
//                   :   Ը 
//                    :  6/03/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  Cobject& p_rco                              
//                                                                       
//                :    CObjectListItem   CObject
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
CObjectListItem::CObjectListItem(CObject& p_rco)
{
	m_pcoliNext=NULL;
	m_pcoliPrevious=NULL;
	SetName(p_rco.GetName());
	SetDescription(p_rco.GetDescription());
	SetImageFileName(p_rco.GetImageFileName());
	
}
///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  AddBefore
//                   :   Ը 
//                    :  6/03/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  CObject & p_rco                              
//                                                                       
//                :    p_rco   this
//                                                                       
//                   :  TRUE   
//                                                                       
///////////////////////////////////////////////////////////////////////////////
BOOL CObjectListItem::AddBefore(CObject & p_rco)
{
	CObjectListItem *pcoli=new CObjectListItem;
	if (!pcoli) return FALSE;
	(*pcoli)=p_rco;
	pcoli->m_pcoliNext=this;
	pcoli->m_pcoliPrevious=this->m_pcoliPrevious;

	if (this->m_pcoliPrevious) 
	{
		this->m_pcoliPrevious->m_pcoliNext=pcoli;
	}
	this->m_pcoliPrevious=pcoli;
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  AddAfter
//                   :   Ը 
//                    :  6/03/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  CObject & p_rco                              
//                                                                       
//                :   p_rco  this
//                                                                       
//                   :  TRUE   
//                                                                       
///////////////////////////////////////////////////////////////////////////////
BOOL CObjectListItem::AddAfter(CObject & p_rco)
{
	CObjectListItem *pcoli=new CObjectListItem;
	if (!pcoli) return FALSE;
	(*pcoli)=p_rco;
	pcoli->m_pcoliNext=this->m_pcoliNext;
	pcoli->m_pcoliPrevious=this;
	if (this->m_pcoliNext)
	{
		this->m_pcoliNext->m_pcoliPrevious=pcoli;
	}
	this->m_pcoliNext=pcoli;
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  
//                   :   Ը 
//                    :  6/03/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                
//                                                                       
//                :   this    
//                             
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
CObjectListItem::~CObjectListItem()
{
	if (this->m_pcoliPrevious)
	{
		this->m_pcoliPrevious->m_pcoliNext=this->m_pcoliNext;
	}
	if (this->m_pcoliNext)
	{
		this->m_pcoliNext->m_pcoliPrevious=this->m_pcoliPrevious;
	}
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  operator =
//                   :   Ը 
//                    :  6/03/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  CObjectListItem & p_rcoObjectListItem                             
//                                                                       
//                :   
//                                                                       
//                   :  const CObjectListItem &
//                                                                       
///////////////////////////////////////////////////////////////////////////////
const CObjectListItem & CObjectListItem::operator =(CObjectListItem &p_rcoObjectListItem)
{
	CObject::operator =(p_rcoObjectListItem);
	return *this;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  operator =
//                   :   Ը 
//                    :  6/03/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  CObject & p_rco                             
//                                                                       
//                :   
//                                                                       
//                   :  const CObjectListItem &
//                                                                       
///////////////////////////////////////////////////////////////////////////////
const CObjectListItem & CObjectListItem::operator =(CObject& p_rco)
{
	CObject::operator =(p_rco);
	return *this;
}